import {Component, Input, OnInit} from '@angular/core';
import {GameModel} from "../../../../game-model/GameModel";
import {SimpleGamesystem} from "../../../../game-model/gamesystems/SimpleGamesystem";
import {
  MatCell,
  MatCellDef,
  MatColumnDef,
  MatHeaderCell,
  MatHeaderCellDef, MatHeaderRow, MatHeaderRowDef, MatRow, MatRowDef,
  MatTable,
  MatTableDataSource
} from "@angular/material/table";
import {SimpleTransition} from "../../../../game-model/gamesystems/SimpleTransition";
import {animate, state, style, transition, trigger} from "@angular/animations";

@Component({
  selector: 'app-simple-transition-editor',
  templateUrl: './simple-transition-editor.component.html',
  styleUrl: './simple-transition-editor.component.scss',
  animations: [
    trigger('detailExpand', [
      state('collapsed,void', style({height: '0px', minHeight: '0'})),
      state('expanded', style({height: '*'})),
      transition('expanded <=> collapsed', animate('225ms cubic-bezier(0.4, 0.0, 0.2, 1)')),
    ]),
  ],
})
export class SimpleTransitionEditorComponent implements OnInit {

  @Input() gamesystem: SimpleGamesystem | undefined
  displayedColumns: string[] = ["starting-state", "ending-state", "edit", "delete"];
  dataSource = new MatTableDataSource<SimpleTransition>();
  columnsToDisplayWithExpand = [...this.displayedColumns, 'expand'];
  expandedElement: SimpleTransition | null = null;
  ngOnInit() {
    this.dataSource.data = this.gamesystem!.transitions;
  }
}
